=== modified file 'bzrlib/commit.py'
--- bzrlib/commit.py	2011-02-08 15:35:14 +0000
+++ bzrlib/commit.py	2011-03-12 23:58:55 +0000
@@ -326,7 +326,7 @@
                 minimum_path_selection(specific_files))
         else:
             self.specific_files = None
-            
+
         self.allow_pointless = allow_pointless
         self.message_callback = message_callback
         self.timestamp = timestamp
@@ -404,6 +404,10 @@
             self.config, timestamp, timezone, committer, self.revprops, rev_id)
 
         try:
+            if (not self.builder.supports_record_entry_contents and
+                not self.use_record_iter_changes):
+                raise errors.ExcludesUnsupported(self.branch.repository)
+
             self.builder.will_record_deletes()
             # find the location being committed to
             if self.bound_branch:

=== modified file 'bzrlib/errors.py'
--- bzrlib/errors.py	2011-02-25 12:12:39 +0000
+++ bzrlib/errors.py	2011-03-12 23:58:55 +0000
@@ -1140,6 +1140,15 @@
         BzrError.__init__(self, files=files, files_str=files_str)
 
 
+class ExcludesUnsupported(BzrError):
+
+    _fmt = ('Excluding paths during commit is not supported by '
+            'repository at %(repository)r.')
+
+    def __init__(self, repository):
+        BzrError.__init__(self, repository=repository)
+
+
 class BadCommitMessageEncoding(BzrError):
 
     _fmt = 'The specified commit message contains characters unsupported by '\

=== modified file 'bzrlib/repository.py'
--- bzrlib/repository.py	2011-03-09 01:33:12 +0000
+++ bzrlib/repository.py	2011-03-12 23:58:55 +0000
@@ -94,6 +94,8 @@
     record_root_entry = True
     # the default CommitBuilder does not manage trees whose root is versioned.
     _versioned_root = False
+    # this commit builder supports the record_entry_contents interface
+    supports_record_entry_contents = True
 
     def __init__(self, repository, parents, config, timestamp=None,
                  timezone=None, committer=None, revprops=None,

